local OVALE, Ovale = ...
local OvaleScripts = Ovale.OvaleScripts

do
	local name = "ovale_priest_spells"
	local desc = "[6.0.2] Ovale: Priest spells"
	local code = [[
# Priest spells and functions.

Define(auspicious_spirits_talent 21)
Define(cascade_caster 121135)
	SpellInfo(cascade_caster cd=25)
Define(cascade_talent 16)
Define(clarity_of_power 155246)
Define(clarity_of_power_talent 19)
Define(devouring_plague 2944)
	SpellInfo(devouring_plague shadoworbs=finisher min_shadoworbs=3)
	SpellAddBuff(devouring_plague shadow_word_insanity_buff=1 talent=insanity_talent)
	SpellAddTargetDebuff(devouring_plague devouring_plague_debuff=1)
	SpellAddTargetDebuff(devouring_plague void_entropy_debuff=refresh if_spell=void_entropy)
Define(devouring_plague_debuff 158831)
	SpellInfo(devouring_plague_debuff duration=6 haste=spell tick=1)
Define(dispersion 47585)
	SpellInfo(dispersion cd=120)
	SpellInfo(dispersion addcd=-15 glyph=glyph_of_dispersion)
Define(divine_star_caster 110744)
	SpellInfo(divine_star_caster cd=15)
Define(divine_star_talent 17)
Define(enhanced_mind_flay 157223)
Define(enhanced_shadow_word_death 157218)
Define(glyph_of_dispersion 63229)
Define(glyph_of_mind_harvest 162532)
Define(glyph_of_shadow_word_death 120583)
Define(glyph_of_silence 159626)
Define(halo_caster 120644)
	SpellInfo(halo_caster cd=40)
Define(halo_talent 18)
Define(insanity 129197)
	SpellInfo(insanity channel=3 buff=shadow_word_insanity_buff)
	SpellInfo(insanity channel=2 if_spell=enhanced_mind_flay)
	SpellInfo(insanity unusable=1 talent=!insanity_talent)
Define(insanity_talent 9)
Define(mind_blast 8092)
	SpellInfo(mind_blast cd=9 cd_haste=spell shadoworbs=-1)
	SpellInfo(mind_blast addcd=-3 if_spell=clarity_of_power)
	SpellInfo(mind_blast addcd=6 glyph=glyph_of_mind_harvest)
	SpellAddBuff(mind_blast shadowy_insight_buff=0 if_spell=shadowy_insight)
Define(mind_flay 15407)
	SpellInfo(mind_flay channel=3 haste=spell)
	SpellInfo(mind_flay channel=2 if_spell=enhanced_mind_flay)
	SpellRequire(mind_flay replace insanity=buff,shadow_word_insanity_buff talent=insanity_talent)
Define(mind_sear 48045)
	SpellInfo(mind_sear channel=5 haste=spell)
Define(mind_spike 73510)
	SpellAddBuff(mind_spike surge_of_darkness_buff=-1 if_spell=surge_of_darkness)
	SpellAddTargetDebuff(mind_spike devouring_plague_debuff=0,buff,!surge_of_darkness_buff)
	SpellAddTargetDebuff(mind_spike shadow_word_pain_debuff=0,buff,!surge_of_darkness_buff)
	SpellAddTargetDebuff(mind_spike vampiric_touch_debuff=0,buff,!surge_of_darkness_buff)
	SpellAddTargetDebuff(mind_spike void_entropy_debuff=0,buff,!surge_of_darkness_buff if_spell=void_entropy)
Define(mindbender 123040)
	SpellInfo(mindbender cd=60)
Define(mindbender_talent 8)
Define(power_infusion 10060)
	SpellInfo(power_infusion cd=120 gcd=0)
Define(power_infusion_talent 14)
Define(power_word_fortitude 21562)
	SpellAddBuff(power_word_fortitude power_word_fortitude_buff=1)
Define(power_word_fortitude_buff 21562)
	SpellInfo(power_word_fortitude_buff duration=3600)
Define(shadow_word_death 32379)
	SpellInfo(shadow_word_death cd=8 shadoworbs=-1 target_health_pct=20)
	SpellInfo(shadow_word_death buff_shadoworbs=shadow_word_death_reset_cooldown_buff buff_shadoworbs_amount=1 if_spell=!enhanced_shadow_word_death)
Define(shadow_word_death_glyphed 129176)
	SpellInfo(shadow_word_death_glyphed cd=8 shadoworbs=-1)
	SpellInfo(shadow_word_death_glyphed buff_shadoworbs=shadow_word_death_reset_cooldown_buff buff_shadoworbs_amount=1 if_spell=!enhanced_shadow_word_death)
Define(shadow_word_death_reset_cooldown_buff 125927)	# OvaleShadowWordDeath
	SpellInfo(shadow_word_death_reset_cooldown_buff duration=9)
Define(shadow_word_insanity_buff 132573)
	SpellInfo(shadow_word_insanity_buff duration=6)
Define(shadow_word_pain 589)
	SpellAddTargetDebuff(shadow_word_pain shadow_word_pain_debuff=1)
Define(shadow_word_pain_debuff 589)
	SpellInfo(shadow_word_pain_debuff duration=18 haste=spell tick=3)
	SpellInfo(shadow_word_pain_debuff addduration=3 itemset=T14_caster itemcount=4)
Define(shadowfiend 34433)
	SpellInfo(shadowfiend cd=180)
Define(shadowform 15473)
	SpellInfo(shadowform to_stance=priest_shadowform if_stance=!priest_shadowform)
	SpellAddBuff(shadowform shadowform_buff=1 if_stance=!priest_shadowform)
	SpellAddBuff(shadowform shadowform_buff=0 if_stance=priest_shadowform)
Define(shadowform_buff 15473)
Define(shadowy_insight 162452)
Define(shadowy_insight_buff 124430)
	SpellInfo(shadowy_insight_buff duration=12)
Define(silence 15487)
	SpellInfo(silence cd=45 gcd=0 interrupt=1)
	SpellInfo(silence addcd=-25 glyph=glyph_of_silence)
Define(surge_of_darkness 87160)
Define(surge_of_darkness_buff 87160)
	SpellInfo(surge_of_darkness_buff duration=10 max_stacks=3)
Define(surge_of_darkness_talent 7)
Define(vampiric_touch 34914)
	SpellAddTargetDebuff(vampiric_touch vampiric_touch_debuff=1)
Define(vampiric_touch_debuff 34914)
	SpellInfo(vampiric_touch_debuff duration=15 haste=spell tick=3)
	SpellInfo(vampiric_touch_debuff addduration=3 itemset=T14_caster itemcount=4)
Define(void_entropy 155361)
	SpellInfo(void_entropy shadoworbs=finisher min_shadoworbs=3)
	SpellAddBuff(void_entropy shadow_word_insanity_buff=1 talent=insanity_talent)
	SpellAddTargetDebuff(void_entropy void_entropy_debuff=1)
Define(void_entropy_debuff 155361)
	SpellInfo(void_entropy_debuff duration=60 haste=spell tick=3)
Define(void_entropy_talent 20)
]]

	OvaleScripts:RegisterScript("PRIEST", name, desc, code, "include")
end
